Index: main/waeup.fceokene/trunk/src/waeup/fceokene/locales/de/LC_MESSAGES/waeup.fceokene.po
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/locales/de/LC_MESSAGES/waeup.fceokene.po	(revision 8462)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/locales/de/LC_MESSAGES/waeup.fceokene.po	(revision 9147)
@@ -15,5 +15,5 @@
 msgstr ""
 "Project-Id-Version: WAeUP.Kofa\n"
-"POT-Creation-Date: Wed May 16 15:24:55 2012\n"
+"POT-Creation-Date: Mon Sep  3 12:52:46 2012\n"
 "PO-Revision-Date: 2012-05-16 15:26+0100\n"
 "Last-Translator: Henrik Bettermann <henrik@waeup.org>\n"
@@ -28,183 +28,4 @@
 "X-Poedit-SourceCharset: utf-8\n"
 
-#. Default: ""
-#: waeup/fceokene/applicants/browser.py:165
-#: waeup/fceokene/students/browser.py:212
-msgid ""
-"<br /><br /><br />\n"
-"The tranzaction code for eTranzact payments is <strong>${a}</strong>."
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:104
-#: waeup/fceokene/students/interfaces.py:203
-#: waeup/fceokene/students/interfaces.py:247
-msgid "Institution Attended"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:109
-#: waeup/fceokene/students/interfaces.py:209
-#: waeup/fceokene/students/interfaces.py:253
-msgid "Years Attended"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:114
-#: waeup/fceokene/students/interfaces.py:215
-#: waeup/fceokene/students/interfaces.py:259
-msgid "Discipline"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:130
-msgid "If yes, name of institution"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:135
-#: waeup/fceokene/students/interfaces.py:265
-msgid "Nysc Year"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:141
-#: waeup/fceokene/students/interfaces.py:272
-msgid "Nysc Location"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:145
-#: waeup/fceokene/students/interfaces.py:277
-msgid "Employer"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:150
-#: waeup/fceokene/students/interfaces.py:283
-msgid "Employer Position"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:155
-#: waeup/fceokene/applicants/interfaces.py:182
-#: waeup/fceokene/students/interfaces.py:289
-#: waeup/fceokene/students/interfaces.py:321
-msgid "Start Date"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:161
-#: waeup/fceokene/applicants/interfaces.py:188
-#: waeup/fceokene/students/interfaces.py:296
-#: waeup/fceokene/students/interfaces.py:327
-msgid "End Date"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:167
-#: waeup/fceokene/applicants/interfaces.py:194
-#: waeup/fceokene/students/interfaces.py:303
-#: waeup/fceokene/students/interfaces.py:334
-msgid "Reason for Leaving"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:172
-#: waeup/fceokene/students/interfaces.py:309
-msgid "2nd Employer"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:177
-#: waeup/fceokene/students/interfaces.py:315
-msgid "2nd Employer Position"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:199
-msgid "Notice"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:204
-msgid "Screening Venue"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:209
-msgid "Screening Score"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:214
-msgid "Admitted Course of Study"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:41
-#: waeup/fceokene/applicants/interfaces.py:64
-#: waeup/fceokene/students/interfaces.py:74
-msgid "Nationality"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:46
-#: waeup/fceokene/applicants/interfaces.py:69
-#: waeup/fceokene/students/interfaces.py:80
-msgid "State/LGA (Nigerians only)"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:73
-msgid "Permanent Address"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:77
-msgid "1st Choice Course of Study"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:82
-msgid "2nd Choice Course of Study"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:87
-#: waeup/fceokene/applicants/interfaces.py:119
-#: waeup/fceokene/students/interfaces.py:183
-#: waeup/fceokene/students/interfaces.py:227
-msgid "Qualification Obtained"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:93
-#: waeup/fceokene/students/interfaces.py:190
-#: waeup/fceokene/students/interfaces.py:234
-msgid "Former Matric Number"
-msgstr ""
-
-#: waeup/fceokene/applicants/interfaces.py:98
-#: waeup/fceokene/students/interfaces.py:196
-#: waeup/fceokene/students/interfaces.py:240
-msgid "Class of Degree"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:48
-msgid "Base Data"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:49
-msgid "Programmes/Courses Desired"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:50
-#: waeup/fceokene/students/utils.py:137
-msgid "Higher Education Record"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:51
-msgid "Course or Programme Presently Attending"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:52
-#: waeup/fceokene/students/utils.py:139
-msgid "NYSC Information"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:53
-#: waeup/fceokene/students/utils.py:140
-msgid "Employment History"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:54
-msgid "Application Process Information"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:55
-msgid "Post Primary School Qualification"
-msgstr ""
-
-#: waeup/fceokene/applicants/utils.py:56
-msgid "Presently attending a course or programme"
-msgstr ""
-
 #: waeup/fceokene/browser/theming.py:30
 #, fuzzy
@@ -212,441 +33,115 @@
 msgstr "Benutzerdefiniertes Thema 1"
 
-#: waeup/fceokene/etranzact/browser.py:100
-#: waeup/fceokene/etranzact/browser.py:108
-msgid "Query eTranzact History"
+#: waeup/fceokene/interfaces.py:35
+msgid "School Fee (ignored)"
+msgstr "Schulgebühr (wird nicht verwendet)"
+
+#: waeup/fceokene/interfaces.py:41
+msgid "Application Fee (fallback)"
 msgstr ""
 
-#: waeup/fceokene/etranzact/browser.py:119
-msgid "Submit to eTranzact"
+#: waeup/fceokene/interfaces.py:47
+#, fuzzy
+msgid "Clearance Fee"
+msgstr "Einschreibungsgebühr"
+
+#: waeup/fceokene/interfaces.py:53
+msgid "Booking Fee"
+msgstr "Buchungsgebühr"
+
+#: waeup/fceokene/interfaces.py:61
+#, fuzzy
+msgid "Maintenance Fee (ignored)"
+msgstr "Miete"
+
+#: waeup/fceokene/interfaces.py:67
+msgid "Gown Fee"
+msgstr "Talar-Gebühr"
+
+#: waeup/fceokene/interfaces.py:73
+msgid "Transfer Fee"
+msgstr "Studienfachwechselgebühr"
+
+#: waeup/fceokene/interfaces.py:88
+msgid "Academic Session"
+msgstr "Akademisches Jahr"
+
+#. Default: ""
+#: waeup/fceokene/interswitch/browser.py:103
+msgid "Unsuccessful callback: ${a}"
 msgstr ""
 
-#: waeup/fceokene/etranzact/browser.py:120
-msgid "Requery eTranzact History"
+#: waeup/fceokene/interswitch/browser.py:108
+msgid "Callback amount does not match."
 msgstr ""
 
-#: waeup/fceokene/etranzact/browser.py:139
-#: waeup/fceokene/etranzact/browser.py:167
-#: waeup/fceokene/interswitch/browser.py:406
-#: waeup/fceokene/interswitch/browser.py:434
+#: waeup/fceokene/interswitch/browser.py:113
+msgid "Callback transaction id does not match."
+msgstr ""
+
+#: waeup/fceokene/interswitch/browser.py:119
+msgid "Successful callback received"
+msgstr ""
+
+#: waeup/fceokene/interswitch/browser.py:128
+#: waeup/fceokene/interswitch/browser.py:142
+msgid "CollegePAY"
+msgstr "CollegePAY"
+
+#: waeup/fceokene/interswitch/browser.py:156
+#: waeup/fceokene/interswitch/browser.py:164
+#, fuzzy
+msgid "Requery CollegePAY"
+msgstr "CollegePAY"
+
+#: waeup/fceokene/interswitch/browser.py:175
+#: waeup/fceokene/interswitch/browser.py:254
+msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
+msgstr "Daten an CollegePAY (Interswitch Payment Gateway) senden"
+
+#: waeup/fceokene/interswitch/browser.py:176
+#: waeup/fceokene/interswitch/browser.py:255
+msgid "Submit"
+msgstr "Senden"
+
+#: waeup/fceokene/interswitch/browser.py:186
+#: waeup/fceokene/interswitch/browser.py:264
+msgid "Payment ticket can't be re-send to CollegePAY."
+msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
+
+#: waeup/fceokene/interswitch/browser.py:269
+#, fuzzy
+msgid ""
+"Payment ticket can't be send to CollegePAY. Application period has expired."
+msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
+
+#: waeup/fceokene/interswitch/browser.py:315
+#: waeup/fceokene/interswitch/browser.py:342
 msgid "This ticket has already been paid."
 msgstr ""
 
 #. Default: ""
-#: waeup/fceokene/etranzact/browser.py:47
-msgid "Invalid or unsuccessful callback: ${a}"
-msgstr ""
-
-#. Default: ""
-#: waeup/fceokene/etranzact/browser.py:55
-#: waeup/fceokene/etranzact/browser.py:62
-#: waeup/fceokene/interswitch/browser.py:95
+#: waeup/fceokene/interswitch/browser.py:94
 msgid "Invalid callback: ${a}"
 msgstr ""
 
-#: waeup/fceokene/etranzact/browser.py:67
-msgid "eTranzact IOError"
-msgstr ""
-
-#: waeup/fceokene/etranzact/browser.py:76
-msgid "Wrong amount"
-msgstr ""
-
-#: waeup/fceokene/etranzact/browser.py:85
-msgid "Wrong transaction code"
-msgstr ""
-
-#: waeup/fceokene/etranzact/browser.py:90
-#: waeup/fceokene/interswitch/browser.py:120
-msgid "Successful callback received"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:101
-msgid "Booking Fee"
-msgstr "Buchungsgebühr"
-
-#: waeup/fceokene/interfaces.py:109
-#, fuzzy
-msgid "Maintenance Fee (ignored)"
-msgstr "Miete"
-
-#: waeup/fceokene/interfaces.py:115
-msgid "Gown Fee"
-msgstr "Talar-Gebühr"
-
-#: waeup/fceokene/interfaces.py:121
-msgid "Transfer Fee"
-msgstr "Studienfachwechselgebühr"
-
-#: waeup/fceokene/interfaces.py:136
-msgid "Academic Session"
-msgstr "Akademisches Jahr"
-
-#: waeup/fceokene/interfaces.py:83
-msgid "School Fee (ignored)"
-msgstr "Schulgebühr (wird nicht verwendet)"
-
-#: waeup/fceokene/interfaces.py:89
-msgid "Application Fee"
-msgstr ""
-
-#: waeup/fceokene/interfaces.py:95
-#, fuzzy
-msgid "Clearance Fee (ignored)"
-msgstr "Einschreibungsgebühr"
-
-#. Default: ""
-#: waeup/fceokene/interswitch/browser.py:104
-msgid "Unsuccessful callback: ${a}"
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:109
-msgid "Callback amount does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:114
-msgid "Callback transaction id does not match."
-msgstr ""
-
-#: waeup/fceokene/interswitch/browser.py:129
-#: waeup/fceokene/interswitch/browser.py:143
-msgid "CollegePAY"
-msgstr "CollegePAY"
-
-#: waeup/fceokene/interswitch/browser.py:175
-#: waeup/fceokene/interswitch/browser.py:183
-#, fuzzy
-msgid "Requery CollegePAY"
-msgstr "CollegePAY"
-
-#: waeup/fceokene/interswitch/browser.py:195
-#: waeup/fceokene/interswitch/browser.py:292
-msgid "Submit data to CollegePAY (Interswitch Payment Gateway)"
-msgstr "Daten an CollegePAY (Interswitch Payment Gateway) senden"
-
-#: waeup/fceokene/interswitch/browser.py:196
-#: waeup/fceokene/interswitch/browser.py:293
-msgid "Submit"
-msgstr "Senden"
-
-#: waeup/fceokene/interswitch/browser.py:206
-#: waeup/fceokene/interswitch/browser.py:302
-msgid "Payment ticket can't be re-send to CollegePAY."
-msgstr "Bewertete Bezahl-Tickets können nicht erneut gesendet werden."
-
-#: waeup/fceokene/payments/interfaces.py:29
-msgid "Activation Code"
-msgstr ""
-
-#: waeup/fceokene/payments/interfaces.py:36
-msgid "Response Amount Approved"
-msgstr ""
-
-#: waeup/fceokene/payments/interfaces.py:43
-msgid "Response Code"
-msgstr ""
-
-#: waeup/fceokene/payments/interfaces.py:50
-msgid "Response Description"
-msgstr ""
-
-#: waeup/fceokene/payments/interfaces.py:59
-msgid "Response Payment Reference"
-msgstr ""
-
-#: waeup/fceokene/payments/interfaces.py:66
-msgid "Response Card Number"
-msgstr ""
-
-#: waeup/fceokene/students/browser.py:150
-msgid "No birth certificate uploaded."
-msgstr ""
-
-#: waeup/fceokene/students/browser.py:152
-msgid "No referee letter uploaded."
-msgstr ""
-
-#: waeup/fceokene/students/browser.py:154
-msgid "No acceptance letter uploaded."
-msgstr ""
-
-#: waeup/fceokene/students/browser.py:156
-msgid "No first sitting result uploaded."
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:102
-#: waeup/fceokene/students/interfaces.py:135
-#: waeup/fceokene/students/interfaces.py:168
-msgid "Exam Date"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:109
-#: waeup/fceokene/students/interfaces.py:142
-msgid "Exam Type"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:116
-#: waeup/fceokene/students/interfaces.py:149
-#: waeup/fceokene/students/interfaces.py:175
-msgid "Exam Results"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:340
-msgid "If yes, matric number"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:370
+#: waeup/fceokene/students/interfaces.py:74
 msgid "Payment Level"
 msgstr ""
 
-#: waeup/fceokene/students/interfaces.py:42
-msgid "Registration Number"
+#: waeup/fceokene/students/utils.py:194
+msgid "Amount could not be determined."
+msgstr "Betrag konnte nicht ermittelt werden."
+
+#: waeup/fceokene/students/utils.py:201
+msgid "This type of payment has already been made."
 msgstr ""
 
-#: waeup/fceokene/students/interfaces.py:58
-msgid "Unmarried"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:59
-msgid "Married"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:67
-msgid "Date of Birth"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:85
-msgid "Deferent of Admission"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:91
-#: waeup/fceokene/students/interfaces.py:124
-#: waeup/fceokene/students/interfaces.py:157
-msgid "Full Name"
-msgstr ""
-
-#: waeup/fceokene/students/interfaces.py:96
-#: waeup/fceokene/students/interfaces.py:129
-#: waeup/fceokene/students/interfaces.py:162
-msgid "Exam Number"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:134
-msgid "First Sitting Record"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:135
-msgid "Second Sitting Record"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:136
-msgid "Advanced Level Record"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:138
-msgid "Second Higher Education Record"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:141
-msgid "Former FCEOkene Student"
-msgstr ""
-
-#: waeup/fceokene/students/utils.py:72
+#: waeup/fceokene/students/utils.py:66
 msgid "Session configuration object is not available."
 msgstr "Session-Konfiguration ist nicht verfügbar."
 
-#: waeup/fceokene/students/utils.py:99
-msgid "Amount could not be determined."
-msgstr "Betrag konnte nicht ermittelt werden."
-
-#: waeup/fceokene/students/viewlets.py:100
-msgid "Second Sitting Result Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:116
-#: waeup/fceokene/students/viewlets.py:117
-#: waeup/fceokene/students/viewlets.py:127
-msgid "Higher Qualification Result"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:128
-msgid "Higher Qualification Result Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:144
-#: waeup/fceokene/students/viewlets.py:145
-#: waeup/fceokene/students/viewlets.py:155
-msgid "Second Higher Qualification Result"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:156
-msgid "Second Higher Qualification Result Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:179
-#: waeup/fceokene/students/viewlets.py:180
-#: waeup/fceokene/students/viewlets.py:190
-msgid "Advanced Level Result"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:191
-msgid "Advanced Level Result Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:207
-#: waeup/fceokene/students/viewlets.py:208
-#: waeup/fceokene/students/viewlets.py:218
-msgid "Certificate"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:219
-msgid "Certificate Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:235
-#: waeup/fceokene/students/viewlets.py:236
-#: waeup/fceokene/students/viewlets.py:246
-msgid "Second Certificate"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:247
-msgid "Second Certificate Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:270
-#: waeup/fceokene/students/viewlets.py:271
-#: waeup/fceokene/students/viewlets.py:281
-msgid "Third Certificate"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:282
-msgid "Third Certificate Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:305
-#: waeup/fceokene/students/viewlets.py:306
-#: waeup/fceokene/students/viewlets.py:316
-msgid "Evidence of Name"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:317
-msgid "Evidence of Name Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:32
-#: waeup/fceokene/students/viewlets.py:43
-msgid "LGA Identification"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:33
-#: waeup/fceokene/students/viewlets.py:44
-msgid "LGA Identification Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:333
-#: waeup/fceokene/students/viewlets.py:334
-#: waeup/fceokene/students/viewlets.py:344
-msgid "Result Statement"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:345
-msgid "Result Statement Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:361
-#: waeup/fceokene/students/viewlets.py:362
-#: waeup/fceokene/students/viewlets.py:372
-msgid "Referee Letter"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:373
-msgid "Referee Letter Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:389
-#: waeup/fceokene/students/viewlets.py:390
-#: waeup/fceokene/students/viewlets.py:400
-msgid "Second Referee Letter"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:401
-msgid "Second Referee Letter Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:424
-#: waeup/fceokene/students/viewlets.py:425
-#: waeup/fceokene/students/viewlets.py:435
-msgid "Third Referee Letter"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:436
-msgid "Third Referee Letter Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:459
-#: waeup/fceokene/students/viewlets.py:460
-#: waeup/fceokene/students/viewlets.py:470
-msgid "Statutory Declaration of Good Conduct"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:471
-msgid "Statutory Declaration of Good Conduct Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:487
-#: waeup/fceokene/students/viewlets.py:488
-#: waeup/fceokene/students/viewlets.py:498
-msgid "Letter of Admission"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:499
-msgid "Letter of Admission Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:60
-#: waeup/fceokene/students/viewlets.py:61
-#: waeup/fceokene/students/viewlets.py:71
-msgid "First Sitting Result"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:72
-msgid "First Sitting Result Scan"
-msgstr ""
-
-#: waeup/fceokene/students/viewlets.py:88
-#: waeup/fceokene/students/viewlets.py:89
-#: waeup/fceokene/students/viewlets.py:99
-msgid "Second Sitting Result"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:26
-msgid "Nigeria"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:27
-msgid "Germany"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:28
-msgid "United States"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:29
-msgid "Niger"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:30
-msgid "Benin"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:31
-msgid "Cameroon"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:32
-msgid "United Kingdom"
-msgstr ""
-
-#: waeup/fceokene/utils/utils.py:33
-msgid "France"
+#: waeup/fceokene/students/utils.py:80 waeup/fceokene/students/utils.py:86
+msgid "Study course data are incomplete."
 msgstr ""
 